#
# Configuration stuff for linux-nfs
#

##################################################################
# This is the prefix that will be used for nfsd and mountd. Leave this
# empty, or set to `k'.
KPREFIX		= k

# Optimization level for user space programs
#OPT		= -O2
OPT		= -g -O2

# Use these if you have an a.out compiler
CCMOD		:= $(CC)
LDMOD		:= $(LD)

# Statement of capabilities:
#
# HAVE_NETGROUPS	remove this if you have libc-4.5.26 or
#			earlier.
#
HAVE		= -DHAVE_NETGROUPS

# define this if you want auth_des related programs (not yet supported,
# but coming soon).
# You have to have a working multi-precision arithmetic library for this,
# e.g. gmp-1.3.2 (check out your nearest GNU archive).
#AUTHDES 	= yes

# This define will turn NFSv3 support on or off one day. Not functional yet.
#NFSV3		= yes

# This will turn on some debugging/profiling stuff in the kernel module
ifndef KDEBUG
# KDEBUG	= -DRPC_PROFILE
  KDEBUG	= -DRPC_DEBUG
endif

# Where to install rpc.* daemons etc
BINDIR		= /bin
SBINDIR		= /sbin
USRSBINDIR	= /usr/sbin

# Where and how to install manpages
MANDIR		= /usr/man
MAN1EXT		= 1
MAN5EXT		= 5
MAN8EXT		= 8
MAN9EXT		= 9
MANOWNER	= man
MANGROUP	= man

################# END OF USER SERVICEABLE PARTS ##################
ALLTARGETS	= all clean distclean install installman \
		  depend dep postscript indent

ifndef ARCHFLAGS
  ARCH		= $(shell uname -m)
  FLAGS_i486	= -m486
  FLAGS_i586	= -m486
  FLAGS_alpha	= -mno-fp-regs -ffixed-8
  ARCHFLAGS	= $(FLAGS_$(ARCH))
.EXPORT:	ARCHFLAGS
endif

CC		= gcc
AR		= ar
LD		= ld
RM		= rm -f
LN_S		= ln -sf
RANLIB		= ranlib
INDENT		= indent
RPCGEN		= $(TOP)bin/rpcgen
GETKVER		= $(TOP)tools/getkversion
INSTALL		= install
MAN2PS		= groff -Tps -man

AFLAGS		= -I$(TOP)support/include \
		  -I$(TOP)kernel/include \
		  -I$(TOP)ksrc/include \
		  -Wall $(ARCHFLAGS) -pipe $(HAVE)
# -Wno-unused for 2.1.27 kernel cmsg_nexthdr... yuck.
CFLAGS		= $(OPT) $(AFLAGS) -Wno-unused $(CCOPTS)
KFLAGS		= -D__KERNEL__ -I/usr/src/linux/include $(AFLAGS) -O2 \
		  -fomit-frame-pointer -DMODULE -DMODVERSIONS \
		  -D__NO_VERSION__ $(KDEBUG)
LDFLAGS		= $(OPT) $(LDOPTS) -L$(TOP)support/lib

ifdef NFSV3
 CFLAGS	+= -DNFS3_SUPPORTED
endif

k		= $(KPREFIX)

INSTALLBIN	= $(INSTALL) -o root -g root -m 755
INSTALLSUID	= $(INSTALL) -o root -g root -m 4755
INSTALLMOD	= $(INSTALL) -o root -g root -m 600
INSTALLMAN	= install -o $(MANOWNER) -g $(MANOWNER) -m 644
MAN1DIR		= $(MANDIR)/man$(MAN1EXT)
MAN5DIR		= $(MANDIR)/man$(MAN5EXT)
MAN8DIR		= $(MANDIR)/man$(MAN8EXT)
MAN9DIR		= $(MANDIR)/man$(MAN9EXT)
