/* des.h */
/* Copyright (C) 1993 Eric Young - see linux/lib/des/README for more details */
#ifndef DES_DEFS
#define DES_DEFS

#define ALT_ECB

typedef unsigned char des_cblock[8];
typedef struct des_ks_struct
{
	union	{
		des_cblock _;
		/* make sure things are correct size on machines with
		 * 8 byte longs */
		unsigned long pad[2];
		} ks;
#define _	ks._
} des_key_schedule[16];

#define DES_KEY_SZ 	(sizeof(des_cblock))
#define DES_ENCRYPT	1
#define DES_DECRYPT	0

#define DES_CBC_MODE	0
#define DES_PCBC_MODE	1

int des_cbc_encrypt(des_cblock *input,des_cblock *output,long length,
	des_key_schedule schedule,des_cblock *ivec,int encrypt);
int des_ecb_encrypt(des_cblock *input,des_cblock *output,
	des_key_schedule ks,int encrypt);
int des_encrypt(unsigned long *input,unsigned long *output,
	des_key_schedule ks, int encrypt);
int des_set_key(des_cblock *key,des_key_schedule schedule);
int des_generate_key(des_cblock *key);

#endif
