/*
 * getiversion
 *
 * Get version number for an inode on an ext2 file system.
 */

#include <linux/types.h>
#include <linux/ext2_fs.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdio.h>

int
main(int argc, char **argv)
{
	int	i, fd;
	__u32	vers;

	if (argc <= 1) {
		fprintf(stderr, "usage: getiversion file ...\n");
		return 1;
	}

	for (i = 1; i < argc; i++) {
		if ((fd = open(argv[i], O_RDONLY)) < 0
		 || ioctl(fd, EXT2_IOC_GETVERSION, &vers) < 0) {
			perror(argv[i]);
			continue;
		} else {
			printf("%-20s %d\n", argv[i], vers);
		}
		close(fd);
	}
	return 0;
}
