/*
 * Hacked nlm_prot_xdr.c file
 */

#include "nlm_prot.h"
#define MAXNAMELEN	LM_MAXSTRLEN+1

bool_t
xdr_nlm_stats(XDR * xdrs, nlm_stats * objp)
{
	return xdr_enum(xdrs, (enum_t *) objp);
}

bool_t
xdr_nlm_holder(XDR * xdrs, nlm_holder * objp)
{
	return xdr_bool(xdrs, &objp->exclusive)
	    && xdr_int(xdrs, &objp->svid)
	    && xdr_netobj(xdrs, &objp->oh)
	    && xdr_u_int(xdrs, &objp->l_offset)
	    && xdr_u_int(xdrs, &objp->l_len);
}

bool_t
xdr_nlm_testrply(XDR * xdrs, nlm_testrply * objp)
{
	if (!xdr_nlm_stats(xdrs, &objp->stat))
		return (FALSE);
	if (objp->stat == nlm_denied)
		return xdr_nlm_holder(xdrs, &objp->nlm_testrply_u.holder);
	return (TRUE);
}

bool_t
xdr_nlm_stat(XDR * xdrs, nlm_stat * objp)
{
	return xdr_nlm_stats(xdrs, &objp->stat);
}

bool_t
xdr_nlm_res(XDR * xdrs, nlm_res * objp)
{
	return xdr_netobj(xdrs, &objp->cookie)
	    && xdr_nlm_stat(xdrs, &objp->stat);
}

bool_t
xdr_nlm_testres(XDR * xdrs, nlm_testres * objp)
{
	return xdr_netobj(xdrs, &objp->cookie)
	    && xdr_nlm_testrply(xdrs, &objp->stat);
}

bool_t
xdr_nlm_lock(XDR * xdrs, nlm_lock * objp)
{
	return xdr_string(xdrs, &objp->caller_name, LM_MAXSTRLEN)
	    && xdr_netobj(xdrs, &objp->fh)
	    && xdr_netobj(xdrs, &objp->oh)
	    && xdr_int(xdrs, &objp->svid)
	    && xdr_u_int(xdrs, &objp->l_offset)
	    && xdr_u_int(xdrs, &objp->l_len);
}

bool_t
xdr_nlm_lockargs(XDR * xdrs, nlm_lockargs * objp)
{
	return xdr_netobj(xdrs, &objp->cookie)
	    && xdr_bool(xdrs, &objp->block)
	    && xdr_bool(xdrs, &objp->exclusive)
	    && xdr_nlm_lock(xdrs, &objp->alock)
	    && xdr_bool(xdrs, &objp->reclaim)
	    && xdr_int(xdrs, &objp->state);
}

bool_t
xdr_nlm_cancargs(XDR * xdrs, nlm_cancargs * objp)
{
	return xdr_netobj(xdrs, &objp->cookie)
	    && xdr_bool(xdrs, &objp->block)
	    && xdr_bool(xdrs, &objp->exclusive)
	    && xdr_nlm_lock(xdrs, &objp->alock);
}

bool_t
xdr_nlm_testargs(XDR * xdrs, nlm_testargs * objp)
{
	return xdr_netobj(xdrs, &objp->cookie)
	    && xdr_bool(xdrs, &objp->exclusive)
	    && xdr_nlm_lock(xdrs, &objp->alock);
}

bool_t
xdr_nlm_unlockargs(XDR * xdrs, nlm_unlockargs * objp)
{
	return xdr_netobj(xdrs, &objp->cookie)
	    && xdr_nlm_lock(xdrs, &objp->alock);
}

bool_t
xdr_fsh_mode(XDR * xdrs, fsh_mode * objp)
{
	return xdr_enum(xdrs, (enum_t *) objp);
}

bool_t
xdr_fsh_access(XDR * xdrs, fsh_access * objp)
{
	return xdr_enum(xdrs, (enum_t *) objp);
}

bool_t
xdr_nlm_share(XDR * xdrs, nlm_share * objp)
{
	return xdr_string(xdrs, &objp->caller_name, LM_MAXSTRLEN)
	    && xdr_netobj(xdrs, &objp->fh)
	    && xdr_netobj(xdrs, &objp->oh)
	    && xdr_fsh_mode(xdrs, &objp->mode)
	    && xdr_fsh_access(xdrs, &objp->access);
}

bool_t
xdr_nlm_shareargs(XDR * xdrs, nlm_shareargs * objp)
{
	return xdr_netobj(xdrs, &objp->cookie)
	    && xdr_nlm_share(xdrs, &objp->share)
	    && xdr_bool(xdrs, &objp->reclaim);
}

bool_t
xdr_nlm_shareres(XDR * xdrs, nlm_shareres * objp)
{
	return xdr_netobj(xdrs, &objp->cookie)
	    && xdr_nlm_stats(xdrs, &objp->stat)
	    && xdr_int(xdrs, &objp->sequence);
}

bool_t
xdr_nlm_notify(XDR * xdrs, nlm_notify * objp)
{
	return xdr_string(xdrs, &objp->name, MAXNAMELEN)
	    && xdr_long(xdrs, &objp->state);
}
