/*
 * nfsd
 *
 * This is the user level part of nfsd. This is very primitive, because
 * all the work is now done in the kernel module.
 *
 * Copyright (C) 1995, 1996 Olaf Kirch <okir@monad.swb.de>
 */

#include <stdio.h>
#include <stdlib.h>
#include <getopt.h>
#include "nfslib.h"

static void	usage(void);

#define NFSMAXSERVS	16

int
main(int argc, char **argv)
{
	int	count = 1, c, error, port;

	port = 2049;

	/* FIXME: Check for nfs in /etc/services */

	while ((c = getopt(argc, argv, "hp:")) != EOF) {
		switch(c) {
		case 'p':
			port = atoi(optarg);
			break;
		case 'h':
		default:
			usage();
		}
	}

	if (optind < argc) {
		if ((count = atoi(argv[optind])) > NFSMAXSERVS) {
			/* insane # of servers */
			fprintf(stderr,
				"nfsd: server count too high, using %d\n",
				NFSMAXSERVS);
			count = NFSMAXSERVS;
		}
	}

	if ((error = nfssvc(port, count)) < 0)
		perror("nfssvc");

	return (error != 0);
}

static void
usage(void)
{
	fprintf(stderr, "usage:\n"
			"nfsd nrservs");
	exit(2);
}
