/* 
 * Copyright (c) 1995 Jeffrey A. Uphoff
 *
 * NSM for Linux.
 */

#include "statd.h"
#include "nlist.h"

#ifndef lint
static char vcid[] = "lists.c,v 1.6 1995/10/05 21:00:43 juphoff Exp";
#endif

/*
 * Create a new list and return a pointer to it.
 * This becomes a no-op.
 */
notify_list *
init_list(void)
{
	notify_list    *list;

	list = (notify_list *) xmalloc(sizeof(notify_list));
	NL_FIRST(list) = (notify_list *) xmalloc(sizeof(notify_list));
	NL_PREV(list) = NULL;
	NL_PREV(NL_FIRST(list)) = list;
	NL_NEXT(NL_FIRST(list)) = NULL;
	NL_ADDR(list) = 0;
	NL_STATE(list) = 0;
	NL_TIMES(list) = 0;
	NL_MY_NAME(list) = NULL;
	NL_MY_NAME(NL_FIRST(list)) = NULL;
	NL_MON_NAME(list) = NULL;
	NL_MON_NAME(NL_FIRST(list)) = NULL;
	return (list);
}


/*
 * Walk through a list and zap each element, then zap the list.
 * Normally used on already-empty lists (just head & tail left), though
 * crash-simulation requests call it to zap an active list.
 */
void
kill_list(notify_list ** list)
{
	notify_list    *tmpnl;

	for (tmpnl = NL_FIRST(*list); NL_NEXT(tmpnl); tmpnl = NL_NEXT(tmpnl)) {
		NL_DEL_FREE(tmpnl);
	}
	free(NL_FIRST(*list));
	free(*list);
	*list = NULL;
}


/*
 * Walk a list looking for a matching name in the NL_MON_NAME field.
 */
notify_list    *
check_list_for_host(char *host, notify_list * list, short int my_not_mon)
{
	static notify_list *tmpnl;

	for (tmpnl = NL_PREV(list) ? list : NL_FIRST(list); NL_NEXT(tmpnl);
		tmpnl = NL_NEXT(tmpnl))
		if (!strcasecmp(host, my_not_mon ? NL_MY_NAME(tmpnl) :
				NL_MON_NAME(tmpnl)))
			return (tmpnl);

	return ((notify_list *) NULL);
}
